#!/bin/sh

# uvspec tools directory
tools="../../tools/"

# space-separated list of filter functions
filter="ch039 ch062 ch073 ch087 ch097 ch108 ch120 ch134"

# output:  1  irradiance/radiance 
#          2  brightness temperature
output=1

#########################################
# don't change anything below this line #
#########################################


for flt in $filter; do
  cat uvspec.template | sed 's/CHANNEL/'$flt'.bands/' | sed 's/transmittance_wl_file/thermal_bands_file   /' > uvspec.inp
  echo source thermal  >> uvspec.inp
  echo filter_function_file $flt.trm >> uvspec.inp

  if `test $output = 1`; then
    echo ... irradiance/radiance for $flt
  else
    echo ... brightness temperatures for $flt
    echo brightness >> uvspec.inp
  fi

  $tools/uvspec < uvspec.inp > $flt.thermal
done
