/* @(#)sslidar.h
 */

#ifndef _SSLIDAR_H
#define _SSLIDAR_H 1

int ss_lidar (/* input: atmosphere */
	      int nlyr,          /* nlyr */
	      float *z,          /* = z-levels, including the zout-level */
	      float altitude,    /* = altitude at which surface is */
	      float *dtau,       /* = dtauc in uvspec */
	      float *omega_0,    /* = ssalb */
	      double *phase_back,/* = phase function in backward direction (theta=180degrees) */
	      double albedo,
	      /* input: lidar */
	      float lambda,      /* laser wavelength */
	      double E_0,        /* laser shot energy */
	      float zout,        /* lidar position */
	      double umu,        /* cos(zenith angle) */
	      int nranges,       /* nranges */ 
	      double range_width,/* range bin width */
	      float *ranges,     /* particular ranges */
	      double efficiency, /* efficiency */
	      double area,       /* detector area */
	      /* OUTPUT / RESULT */
	      float *nphot,      /* number of photons detected per range bin */
	      float *lidar_ratio /* lidar ratio for each range bin */
	      );

#endif /* _SSLIDAR_H */

