/*--------------------------------------------------------------------
 * $Id: tipa.h,v 1.1 2010/07/08 14:39:50 robert Exp $
 * 
 * This file is part of libRadtran.
 * Copyright (c) 1997-2001 by Arve Kylling and Bernhard Mayer.
 * 
 * ######### Contact info: http://www.libradtran.org #########
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License   
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.        
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the   
 * GNU General Public License for more details.                    
 * 
 * You should have received a copy of the GNU General Public License          
 * along with this program; if not, write to the Free Software                
 * Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *--------------------------------------------------------------------*/

#ifndef __tipa_h
#define __tipa_h

#include "../src/uvspec.h"
#include "../src/solve_rte.h"

int mc_tipa_dir (cld_out_struct *cld, cld3d_out_struct *cld3d, tipa_struct *tipa, int iv,
		   input_struct input, wl_out_struct *wl);

int tipa_dirdiff (cld3d_out_struct *cld3d, tipa_struct *tipa,
			 int tipaswitch, double sza, double phi0,
			 float *zout,
			 int mctipa);

int tipa_xyzintersec (cld3d_out_struct *cld3d, tipa_struct *tipa, int mctipa);

int tipa_dirtilt (cld3d_out_struct *cld3d, atm_out_struct atm, alt_out_struct alt,
		         tipa_struct *tipa,
		         int tipaswitch, double sza, double phi0,
		         int lower_wl_id, int upper_wl_id,
			 int mctipa);

int tipa_calcdtau (cld_out_struct *cld, cld3d_out_struct cld3d, tipa_struct *tipa,
		   int iipa, int jipa, int iv,
		   input_struct input, wl_out_struct *wl); /* ulrike */

#endif



